<template>
  <div class="module module-partners">
    <div class="row justify-content-center">
      <div class="col-12 col-md-10 col-lg-8 col-xl-6">
        <h2 class="text-center" v-html="$stripPTags(data.headline)" />
      </div>
    </div>
    <div
      v-if="$mq === 'xs' || $mq === 'sm' || $mq === 'md'"
      class="module-partners-mobile"
    >
      <atom-slider
        ref="flickity"
        class="main-carousel flickity"
        :options="flickityOptions"
      >
        <div
          v-for="(icon, index) in data.icons"
          :key="index"
          class="carousel-cell slide"
        >
          <div class="text-wrapper">
            <div class="d-block position-relative">
              <component
                :is="icon.link ? 'a' : 'div'"
                :href="icon.link"
                :target="icon.link ? '_blank' : ''"
                class="partner-img"
              >
                <atom-image
                  v-if="isPixelGraphic(icon)"
                  :image="icon.logo"
                  ratio="variable"
                  :lazyload="false"
                />
                <img
                  v-else
                  class="icon"
                  :src="icon.logo.sourceUrl"
                  :alt="icon.logo.altText"
                />
              </component>
              <p class="text">{{ icon.text }}</p>
            </div>
          </div>
        </div>
      </atom-slider>
      <div
        v-if="$mq === 'xs' || $mq === 'sm' || $mq === 'md'"
        class="flickity-mobile-controls"
      >
        <button
          class="flickity-button flickity-prev-next-button previous"
          type="button"
          aria-label="Previous"
          @click="$refs.flickity.previous()"
        >
          <svg
            xmlns="http://www.w3.org/2000/svg"
            viewBox="0 0 48 23"
            style="enable-background: new 0 0 48 23"
            xml:space="preserve"
          >
            <path d="m35.6 0-2 2 8.3 8.3H-1v2.8h42.5L33.6 21l2 2L47 11.5z" />
          </svg>
        </button>
        <ol class="flickity-page-dots">
          <li
            v-for="(slide, index) in data.icons"
            :key="index"
            class="dot"
            :class="{ 'is-selected': selectedSlide === index }"
            @click="$refs.flickity.select(index)"
          ></li>
        </ol>
        <button
          class="flickity-button flickity-prev-next-button next"
          type="button"
          aria-label="Next"
          @click="$refs.flickity.next()"
        >
          <svg
            xmlns="http://www.w3.org/2000/svg"
            viewBox="0 0 48 23"
            style="enable-background: new 0 0 48 23"
            xml:space="preserve"
          >
            <path d="m35.6 0-2 2 8.3 8.3H-1v2.8h42.5L33.6 21l2 2L47 11.5z" />
          </svg>
        </button>
      </div>
    </div>
    <div v-else class="module-partners-desktop">
      <div class="row justify-content-center">
        <div
          v-for="(icon, index) in data.icons"
          :key="index"
          class="col-12 col-sm-6 col-lg-4 justify-content-center icon-tile"
        >
          <component
            :is="icon.link ? 'a' : 'div'"
            :href="icon.link"
            :target="icon.link ? '_blank' : ''"
            class="partner-img"
          >
            <atom-image
              v-if="isPixelGraphic(icon)"
              class="partner-img"
              :image="icon.logo"
              ratio="variable"
            />
            <img
              v-else
              class="icon"
              :src="icon.logo.sourceUrl"
              :alt="icon.logo.altText"
            />
          </component>
          <p class="text">{{ icon.text }}</p>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
export default {
  props: {
    data: {
      type:Object,
      default: () => {},
    }
  },
  data() {
    return {
      selectedSlide: 0,
      flickityOptions: {
          wrapAround: true,
          cellAlign: 'left',
          autoPlay: false,
          draggable: true,
          contain: true,
          selectedAttraction: 0.025,
          friction: 0.3,
          prevNextButtons: false,
          pageDots: false,
          arrowShape: 'M79.6 8.8 70.4 0l-50 50 50 50 9.2-8.8L38.3 50z',
          adaptiveHeight: true,
          imagesLoaded: true,
          // any options from Flickity can be used
      },
    };
  },
  mounted() {
    this.$nextTick(() => {
      this.$nextTick(() => {
        if (this.$refs.flickity) {
          this.$refs.flickity.on('change', (index) => {
            this.selectedSlide = index;
          });
        }
      });
    });
  },
  methods: {
    isPixelGraphic(icon) {
      if (icon.logo && icon.logo.mediaDetails && icon.logo.mediaDetails.sizes.length) {
        return !icon.logo.mediaDetails.sizes[0].sourceUrl.endsWith('.svg');
      }
      return false;
    },
  },
};
</script>

<style lang="scss">
.module-partners {
  padding-bottom: 0rem;

  @include media-breakpoint-up(md) {
    padding-bottom: 1rem;
  }

  @include media-breakpoint-up(lg) {
    padding-bottom: 6rem;
  }

  .icon-tile {
    padding: 1.5rem 0 2rem;
  }

  .icon {
    display: block;
    width: auto;
    max-height: 8rem;
    height: 100%;
    margin: 0 auto;

    @include media-breakpoint-up(lg) {
      margin-bottom: 0.5rem;
    }
  }

  .partner-img {
    position: relative;
    display: block;
    width: 240px;
    height: 200px;
    margin: 0 auto;
    filter: saturate(0);
    transition: filter 0.3s linear;

    &:hover {
      filter: saturate(1);
    }

    @include media-breakpoint-up(lg) {
      margin-bottom: 0.5rem;
    }

    .img-container {
      height: 100%;
      width: 100%;
      background: transparent !important;
    }

    img {
      position: absolute;
      max-width: 100%;
      max-height: 100%;
      width: auto;
      height: auto;
      top: 50% !important;
      left: 50% !important;
      transform: translate(-50%, -50%) !important;
    }

    .icon {
      width: 200px;
      height: 200px;
    }
  }

  .text {
    display: block;
    text-align: center;
    font-weight: 600;
    font-size: 1.5rem;
    line-height: 1.333em;
    max-width: 324px;
    margin: 0 auto;
  }

  .module-partners-mobile {
    margin-top: 0.5rem;

    .flickity-viewport {
      transition: height 0.35s;
    }

    .text-wrapper {
      display: block;
      padding-top: 0;
      padding-bottom: 0;
      margin-top: 0;
      margin-bottom: 0;
      height: 100%;

      > {
        position: relative;
        display: block;
      }
    }
  }

  .flickity-mobile-controls {
    @include media-breakpoint-up(md) {
      display: flex;
    }
    @include media-breakpoint-up(lg) {
      display: none;
    }
  }

  .flickity-page-dots {
    display: block;
  }
}
</style>
